#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}require("loud-rejection/register");var chalk=require("chalk"),parse=_interopDefault(require("minimist")),prettyJson=_interopDefault(require("jsome")),RenderKid=_interopDefault(require("renderkid")),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),TS=_interopDefault(require("trie-search")),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),has=_interopDefault(require("lodash.has")),every=_interopDefault(require("lodash.every")),partial=_interopDefault(require("lodash.partial")),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),executable=_interopDefault(require("rollup-plugin-executable")),semver=require("semver"),cpx=_interopDefault(require("cpx")),rimraf=_interopDefault(require("rimraf")),pick=_interopDefault(require("lodash.pick")),jsonFile=_interopDefault(require("jsonfile")),rollup=require("rollup"),util=require("util"),map=_interopDefault(require("lodash.map")),configureGit=_interopDefault(require("simple-git/promise")),asyncToGenerator=function(e){return function(){var r=e.apply(this,arguments);return new Promise(function(e,n){function t(i,a){try{var o=r[i](a),s=o.value}catch(e){return void n(e)}if(!o.done)return Promise.resolve(s).then(function(e){t("next",e)},function(e){t("throw",e)});e(s)}return t("next")})}},_extends=Object.assign||function(e){for(var r=1;r<arguments.length;r++){var n=arguments[r];for(var t in n)Object.prototype.hasOwnProperty.call(n,t)&&(e[t]=n[t])}return e},createSearcher=({commands:e=[]}={})=>{const r=e.map(e=>{const r=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...r].join(" ")})}),n=new TS(["tokens"]);return n.addAll(r),n};const configureKli=({defaultStyle:e,defaultRenderer:r=console.log}={})=>({commands:n=[]}={})=>{if(!Array.isArray(n))throw new Error("Commands must be an array");if(0===n.length)throw new Error("No commands defined");if(n.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")}),1===n.length)return{execute:()=>n[0].run()};const t=createSearcher({commands:n});return{execute:n=>{const i=parse(n,{boolean:!0}),a=t.get(i._[0])[0];if(!a)return console.log(chalk.red(`No command associated with \`${i._[0]}\``));const o=Promise.resolve(a.run()),s=a.renderer||r,l=new RenderKid;return l.style(e),o.then(e=>{s(a.template?l.render(a.template(e)):e),a.effect&&i.commit&&a.effect(e)})}}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}},packageListTemplate=({packages:e})=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,checkedPackagesTemplate=({checks:e})=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e.packages).map(([e,r])=>`<item>\n                <title>${e}</title>\n                ${Object.entries(r).filter(([e])=>"publishable"!==e).map(([e,r])=>r?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(r).reduce((e,r)=>e.length>r.length?e:r,0).length+3).join("─")}</check>\n                <check>${r.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    <bar>-</bar>\n    <title>Repository</title>\n    ${Object.entries(e.root).map(([e,r])=>r?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n    `,updatePackagesTemplate=({updates:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be updated</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e).map(([e,{old:r,new:n,type:t}])=>`<item>\n                <title>${e} - ${t}</title>\n                <check>${r} -> ${n}</check>\n            </item>`).join("")}\n    </list>\n    `;const glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>r=>match(e,r);var findPackages=({root:e=".",exclude:r=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n,t){try{const i=path.resolve(e,"src/node_modules");if(!(yield lstat(i)).isDirectory)return t("NO");const a=path.resolve(i,"**/package.json");return n((yield glob(a)).filter(function(e){return!r.some(have(e))}).map(function(r){const n=require(r);return{dir:path.relative(e,path.dirname(r)),name:n.name,version:n.version,bin:n.bin,main:n.main,config:n}}).filter(function(e){return e.name}))}catch(e){return t(e)}});return function(e,r){return n.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),list=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages),collapsePackages=(e,r)=>{if(r.undefined){const n=e.undefined?[...e.undefined,r.undefined]:[r.undefined];return _extends({},e,{undefined:n})}return Object.assign(e,r)};const lstat$2=promisify(fs.lstat);var checkPackage=(()=>{var e=asyncToGenerator(function*(e={},r="."){const n={};n["has package name"]=!!e.name;try{const t=path.resolve(r,e.dir,"readme.md"),i=yield lstat$2(t);n["has readme file"]=!!i.isFile}catch(e){n["has readme file"]=!1}try{if(e.main||!e.bin){const t=path.resolve(r,e.dir,e.main||"index.js"),i=yield lstat$2(t);n["has main and/or all bin files"]=!!i.isFile}if(e.bin){const t=Object.values(e.bin),i=yield Promise.all(t.map(function(n){return path.resolve(r,e.dir,n)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$2(e)});return function(r){return e.apply(this,arguments)}})()));n["has main and/or all bin files"]=!i.some(function(e){return!e.isFile})}}catch(e){n["has main and/or all bin files"]=!1}return Object.values(n).some(function(e){return!e})?{[e.name]:_extends({},n,{publishable:!1})}:{[e.name]:_extends({},n,{publishable:!0})}});return function(){return e.apply(this,arguments)}})();const lstat$1=promisify(fs.lstat);var publishCheck=({root:e,baseConfig:r={},packages:n=[]}={})=>new Promise((()=>{var t=asyncToGenerator(function*(t){if(0===n.length)return t([]);const i=yield Promise.all(n.map(function(r){return checkPackage(r,e)})),a={};try{const r=path.resolve(e,"LICENSE"),n=yield lstat$1(r);a["has root license"]=!!n.isFile}catch(e){a["has root license"]=!1}return a["has required package.json fields"]=every(["description","homepage","author","repository","bugs","license","dependencies"],function(e){return partial(has,e)}(r)),t({root:a,packages:i.reduce(collapsePackages,{})})});return function(e){return t.apply(this,arguments)}})()),findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),checkedPackages=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("checks",publishCheck);const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]};var buildRollupConfigs=({root:e=".",packages:r=[],baseConfig:n={dependencies:{}}}={})=>new Promise(t=>t([].concat(...r.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(r=>Object.values(r.bin).map(t=>({name:r.name,srcDir:path.resolve(e,"src/node_modules",r.name),destDir:path.resolve(e,"dist",r.name),packageConfig:r.config,input:path.resolve(e,"src/node_modules",r.name,t),external:[...Object.keys(n.dependencies),"fs","path","util"],output:[{file:path.resolve(e,"dist",r.name,t),format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[nodeResolve({customResolveOptions:{moduleDirectory:"src/node_modules"},preferBuiltins:!0}),babel(babelConfig),uglify({},uglifyEs.minify),executable(),filesize()]})))))),build=()=>transmute__default({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("unfiltered",findPackages).extend("packages",({unfiltered:e})=>e.filter(e=>e.bin)).extend("configs",buildRollupConfigs),recommendVersions=({packages:e=[]}={})=>{if(!e||e.length<=0)return{};return e.filter(e=>e.name).map(e=>e.version?semver.lt(e.version,"0.1.0")?{[e.name]:{type:"patch",old:e.version,new:semver.inc(e.version,"patch")}}:{[e.name]:{type:"none",old:e.version,new:e.version}}:{[e.name]:{type:"new",old:null,new:"0.0.1"}}).reduce(collapsePackages,{})},version=()=>checkedPackages().extend("filtered",({packages:e,checks:r})=>e.filter(e=>e.version).filter(e=>r.packages[e.name].publishable)).extend("updates",({filtered:e})=>recommendVersions({packages:e}));const removeDir=util.promisify(rimraf),copy=util.promisify(cpx.copy),writeJson=util.promisify(jsonFile.writeFile),requiredProps=["description","homepage","author","repository","bugs","license","dependencies"];var buildPackages=({root:e,baseConfig:r,configs:n=[]}={})=>removeDir(path.resolve(e,"dist")).then(()=>Promise.all(n.map(n=>rollup.rollup({input:n.input,external:n.external,plugins:n.plugins}).then(e=>Promise.all(n.output.map(r=>e.write({file:r.file,format:r.format,banner:n.banner})))).then(()=>Promise.all([copy(path.resolve(e,"LICENSE"),path.resolve(n.destDir),{dereference:!0}),copy(path.resolve(n.srcDir,"readme.md"),path.resolve(n.destDir),{dereference:!0}),writeJson(path.resolve(n.destDir,"package.json"),_extends({},n.packageConfig,pick(r,requiredProps)),{spaces:4})])))));const readJson=util.promisify(jsonFile.readFile),writeJson$1=util.promisify(jsonFile.writeFile),git=configureGit();var updatePackages=({root:e,updates:r,filtered:n})=>(console.log("Updating package.json files..."),Promise.all(n.filter(e=>e.name in r).map(({name:n,dir:t})=>{const i=path.resolve(e,t,"package.json");return readJson(i).then(e=>_extends({},e,{version:r[n].new})).then(e=>writeJson$1(i,e,{spaces:4})).then(()=>({name:n,version:r[n].new,file:i}))})).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Staging files for commit..."),yield git.add(map(e,"file")),e});return function(r){return e.apply(this,arguments)}})()).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Committing updates..."),yield git.commit(`docs(version): Update package versions.\n        \n${e.map(function({name:e,version:r}){return`v${r} ${e}`}).join("\n")}\n`),e});return function(r){return e.apply(this,arguments)}})()).then(e=>(console.log("Tagging commit with package versions..."),Promise.all(e.map(({name:e,version:r})=>git.addTag(`${e}-v${r}`))))));const kli=configure({defaultStyle:process.env.CI?{}:style}),cli=kli({commands:[{name:"list",aliases:["ls"],template:packageListTemplate,run:list},{name:"check",template:checkedPackagesTemplate,run:checkedPackages},{name:"build",renderer:()=>{},run:build,effect:buildPackages},{name:"version",aliases:["update"],template:updatePackagesTemplate,run:version,effect:updatePackages}]});cli.execute(process.argv.slice(2));
